<?php

namespace App\DAO;

use App\DAO\DAOResponse\DAOResponse;
use App\DAO\DAOResponse\DAOResponseInterface;
use App\DAO\Filter\QueryFilter;
use App\DAO\Filter\QueryFilterBuilder;
use App\DAO\Order\QueryOrder;
use App\DAO\Pagination\Pagination;
use App\Entities\CEP\CEP;
use App\Entities\Cliente\Cliente;
use App\Entities\ConfirmacaoEmail\ConfirmacaoEmail;
use App\Entities\Endereco\Endereco;
use App\Entities\CentroCusto\CentroCusto;
use App\Entities\Pessoa\Pessoa;
use App\Entities\PessoaFisica\PessoaFisica;
use App\Entities\Usuario\Usuario;
use App\Entities\UsuarioPerfil\UsuarioPerfil;
use App\Mappers\CentroCustoMapper;
use App\Models\CEPModel;
use App\Models\ClienteModel;
use App\Models\ConfirmacaoEmailModel;
use App\Models\EnderecoModel;
use App\Models\CentroCustoModel;
use App\Models\PessoaFisicaModel;
use App\Models\PessoaModel;
use App\Models\UsuarioModel;
use App\Models\UsuarioPerfilModel;
use App\Services\LogService;
use App\Services\ServiceResponse\ServiceResponseInterface;
use App\Utils\Collections\QueryFilterCollection;
use App\Utils\Collections\QueryOrderCollection;
use App\ViewModels\CentroCusto\CentroCustoUpdateViewModel\CentroCustoUpdateViewModel;
use App\ViewModels\CentroCusto\CentroCustoRegistrationViewModel\CentroCustoRegistrationViewModel;
use Exception;
use Kint\Parser\DOMDocumentPlugin;

class CentroCustoDAO extends DAO {

	public function persistCentroCustoRegistrationVM(CentroCustoRegistrationViewModel $centro_custo_registration_vm): DAOResponse {

		$dao_response = new DAOResponse();
		try {
			$this->db->transStart();
			$centro_custo = $this->persistCentroCustoFromCentroCustoRegistrationVM( $centro_custo_registration_vm );
			$error = $this->db->error();
			if ($error && $error ['code']) {
				$this->setDatabaseErrorsForCentroCustoRegistration( $dao_response, $error );
			} else {
				$dao_response->setStatus( DAOResponseInterface::SUCESS );
				$dao_response->setData( $centro_custo );
				$this->db->transComplete();
			}
		} catch ( Exception $exception ) {
			$this->setDatabaseErrorsForCentroCustoRegistration( $dao_response, $this->db->error() );
		}

		return $dao_response;

	}

	private function setDatabaseErrorsForCentroCustoRegistration(DAOResponse $dao_response, array $error): void {

		if ($error ['code']) {
			$dao_response->setStatus( $error ['code'] );
			$dao_response->setErrors( $this->getDatabaseResponseErrorsForPersistence( $error ) );
		} else {
			$dao_response->setStatus( DAOResponseInterface::DATABASE_CONNECTION_ERROR );
		}
		log_message( 'error', json_encode( $error ) );

	}

	private function persistCentroCustoFromCentroCustoRegistrationVM(CentroCustoRegistrationViewModel &$centro_custo_registration_vm): CentroCusto {

		$centro_custo_model = new CentroCustoModel();
		$centro_custo = CentroCustoMapper::getCentroCustoFromCentroCustoRegistrationVM( $centro_custo_registration_vm );
		$centro_custo_model->registerCentroCusto( $centro_custo );
		if (!$centro_custo->getId()) {
			throw new Exception( 'O cadastro de paciente não foi teve êxito' );
		}
		return $centro_custo;

	}

	public function getCentroCustoList(?Pagination $pagination, ?QueryFilterCollection $query_filter_collection,
			?QueryOrderCollection $query_order_collection = null): DAOResponse {

		$sql = <<<SQL
		    SELECT 
		    id as id,
		    descricao as descricao,
		    criado_em as criado_em,
		    atualizado_em as atualizado_em,
		    desativado_em as desativado_em,
		    criado_por as criado_por,
		    alterado_por as alterado_por,
		    desativado_por as desativado_por 
		    FROM centro_custo
		SQL;
		$binds = [ ];
		return $this->getDAOResponseFromPaginatedSelect( $binds, $pagination, $query_filter_collection, $query_order_collection, $sql,
				function (array $result_array) {
					return CentroCustoMapper::getCentroCustoDetailsVMListFromArray( $result_array );
				} );

	}

	public function getCentroCusto(QueryFilterCollection $query_filter_collection): DAOResponse {

		$sql = '
            SELECT 
            id as id,
            descricao as descricao,
            criado_em as criado_em,
            atualizado_em as atualizado_em,
            desativado_em as desativado_em,
            criado_por as criado_por,
            alterado_por as alterado_por,
            desativado_por as desativado_por 
            FROM centro_custo
        ';
		$binds = [ ];
		return $this->getDAOResponseFromUniqueRowSelect( $binds, $query_filter_collection, $sql,
				function (array $result_array) {
					$centro_custoVM = CentroCustoMapper::getCentroCustoDetailsVMFromArray( $result_array [0] );
					return $centro_custoVM;
				} );

	}

	public function getCentroCustoFromId(int $id_centro_custo) {

		$sql = "  SELECT * FROM centro_custo WHERE id=? ";

		$binds = [ 
				$id_centro_custo
		];
		$query = $this->db->query( $sql, $binds );
		$result_array = $query->getResultArray();

		return ($result_array);

	}

	public function persistCentroCustoUpdateVM(int $id_paciente, CentroCustoUpdateViewModel $centro_custo_update_vm): DAOResponse {

		$dao_response = new DAOResponse();
		$this->db->transStart();
		$status_persistence = $this->persistCentroCustoFromCentroCustoUpdateVM( $id_paciente, $centro_custo_update_vm );
		$error = $this->db->error();
		if ($error && $error ['code']) {
			$this->setDatabaseErrorsForCentroCustoUpdate( $dao_response, $error );
			return $dao_response;
		} else if ($status_persistence) {
			$this->db->transComplete();
			$dao_response->setStatus( DAOResponseInterface::SUCESS );
		}
		$this->db->close();
		return $dao_response;

	}

	private function setDatabaseErrorsForCentroCustoUpdate(DAOResponse $dao_response, array $error): void {

		$dao_response->setStatus( $error ['code'] );
		$dao_response->setErrors( $this->getDatabaseResponseErrorsForPersistence( $error ) );

	}

	private function persistCentroCustoFromCentroCustoUpdateVM(int $id_paciente, CentroCustoUpdateViewModel &$centro_custo_update_vm): bool {

		$centro_custo_model = new CentroCustoModel();
		$centro_custo = CentroCustoMapper::getCentroCustoFromCentroCustoUpdateVM( $centro_custo_update_vm );
		$sucess_update = $centro_custo_model->updateCentroCustoByID( $id_paciente, $centro_custo );
		return $sucess_update;

	}

	private function getDatabaseResponseErrorsForPersistence(array $error): array {

		$dao_response_errors = [ ];
		if ($error && $error ['code']) {
			if ($error ['code'] === DAOResponseInterface::FOREIGN_KEY_DONT_EXISTS) {
				if (strpos( $error ['message'], 'cep' ) !== false) {
					$dao_response_errors ['cep'] = 'Esse CEP não existe.';
				}
			} else if ($error ['code'] === DAOResponseInterface::DUPLICATED_UNIQUE_KEY) {
				if (strpos( $error ['message'], '\'cpf\'' ) !== false) {
					$dao_response_errors ['cpf'] = 'Uma pessoa com esse CPF já está cadastrada no sistema.';
				}
				if (strpos( $error ['message'], '\'pessoa_fisica.rg\'' ) !== false) {
					$dao_response_errors ['rg'] = 'Uma pessoa com esse RG já está cadastrada no sistema.';
				}
				if (strpos( $error ['message'], '\'email\'' ) !== false) {
					$dao_response_errors ['email'] = 'Uma pessoa com esse email já está cadastrada no sistema.';
				}
			}
		}
		return $dao_response_errors;

	}

	public function persistCentroCustoDeleteVM(int $id_paciente): DAOResponse {

		$dao_response = new DAOResponse();
		$this->db->transStart();
		$status_persistence = $this->deleteCentroCusto( $id_paciente );
		$error = $this->db->error();
		if ($error && $error ['code']) {
			$this->setDatabaseErrorsForCentroCustoUpdate( $dao_response, $error );
			return $dao_response;
		} else if ($status_persistence) {
			$this->db->transComplete();
			$dao_response->setStatus( DAOResponseInterface::SUCESS );
		}
		$this->db->close();
		return $dao_response;

	}

	public function deleteCentroCusto(int $id_centro_custo): bool {

		$centro_custo_model = new CentroCustoModel();
		$sucess_update = $centro_custo_model->deleteCentroCustoByID( $id_centro_custo );
		return $sucess_update;

	}

}
